#!/usr/bin/python
# -*- coding: utf8 -*-

import irclib
import ircbot
import re
import time
import urllib
import json
import sys

# Init
class Rabbit(ircbot.SingleServerIRCBot):
	def __init__(self):
		ircbot.SingleServerIRCBot.__init__(self, [("irc.freenode.net", 8001)], "RabbitBot", "RabbitBot")
		
		self.memserv = []
		self.teached = []
		self.logs = ""
		self.translate = {}
		
		# Find a bug
		self.bug_regex = re.compile('bug \d{1,10}')

	def find_bug(self, msg):
		m = self.bug_regex.search(msg)
		if m:
			return m.group(0)
		else:
			return None
	
	# Join #elementary
	def on_welcome(self, serv, ev):
		serv.join("#elementary")
		serv.join("#elementary-dev")
		serv.join("#elementaryweb")

	# When a message is sent
	def on_pubmsg(self, serv, ev):
		try:
			message = ev.arguments()[0]
			bug = self.find_bug(message)
			nick = irclib.nm_to_n(ev.source())
			chan = ev.target()
			
			# Add to logs
			self.logs += "<" + nick + "> " + message + "\n"
				
			# Bug number ?
			if bug:
				serv.privmsg(chan, "https://bugs.launchpad.net/bugs/%s" % (bug.replace("bug ", "")))
			
			# Google search
			if "!google" in message:
				if "|" in message.split("!google")[1]:
					requesteduser = message.split("!google")[1].split("|")[1].strip()
					interesting = message.split("!google")[1].split("|")[0].strip().replace(" ", "+")
					serv.privmsg(chan, requesteduser + ": http://www.google.com/search?q=" + interesting)
				else:
					interesting = message.split("!google")[1].strip().replace(" ", "+")
					serv.privmsg(chan, "http://www.google.com/search?q=" + interesting)
			
			# You should report a bug
			elif "!report" in message:
				if "|" in message.split("!report")[1]:
					requesteduser = message.split("!report")[1].split("|")[1].strip()
					interesting = message.split("!report")[1].split("|")[0].strip().replace(" ", "+")
					serv.privmsg(chan, requesteduser + ": https://bugs.launchpad.net/" + interesting + "/+filebug")
				else:
					interesting = message.split("!report")[1].strip().replace(" ", "+")
					serv.privmsg(chan, "https://bugs.launchpad.net/" + interesting + "/+filebug")
					
			# Ops
			elif "!ops" in message:
				serv.privmsg(chan, "Help! Channel emergency! (ONLY use this trigger in emergencies) - ammonkey, agent00tai, kalikiana, aroman, lallenlowe, Marin_M")
			
			#Thanks
			elif "!thanks" in message:
				serv.privmsg(chan, "You're welcome! But keep in mind I'm just a bot ;)")
							
			# MemServ
			elif "!memo" in message.lower():
				if "|" in message.split("!memo")[1]:
					self.memserv.append([nick, message.split("!memo")[1].split("|")[1].strip(), message.split("!memo")[1].split("|")[0].strip()]);
			
			# Lallenlowe?
			elif "!allensay" in message:
				serv.privmsg(chan, "\o/ -<" + message.split("!allensay")[1].upper())
				serv.privmsg(chan, " |")
				serv.privmsg(chan, "/ \\")
			
			# Help?
			elif "!help" in message.lower():
				znick = nick
				
				if message.split("!help")[1].strip() != "":
					znick = message.split("!help")[1].strip()
				
				serv.notice(znick, "!help - show this help message")
				serv.notice(znick, "!help <user> - show this help message for <user>")
				serv.notice(znick, "!ops - Alert the operators (ONLY use this trigger in emergencies)")
				serv.notice(znick, "!logs - show #elementary's logs")
				serv.notice(znick, "!translate <language> - translate your messages from <language> to English")
				serv.notice(znick, "!translate off - stop translating")
				serv.notice(znick, "!google <search> | <user> - send a link to the Google search <search> to <user>")
				serv.notice(znick, "!report <project> | <user> - send a link to report a bug in the Launchpad project <project> to <user>")
				serv.notice(znick, "!rabbitsay <message> - make a cute little bunny speak <message>")
				serv.notice(znick, "!kick <nick> - kick <nick>, if you're an operator")
				serv.notice(znick, "!memo <message> | <user> - send <message> to <user> when <user> will be connected, if you're an operator")
				serv.notice(znick, "!voice <user> - autovoice for <user> on #elementary-web, if you're an operator")
				serv.notice(znick, "!unvoice <user> - remove autovoice for <user> on #elementary-web")
				serv.notice(znick, "bug <number> - automatically post a link to the Launchpad bug <number>")
				
			# Rabbit?
			elif "!rabbitsay" in message:
				serv.privmsg(chan, "() ()")
				serv.privmsg(chan, "(=\"=) -<" + message.split("!rabbitsay")[1])
				serv.privmsg(chan, "( . )")
				serv.privmsg(chan, "(\")(\")")
			
			elif "!rabbit" in message:
				serv.privmsg(chan, "() ()")
				serv.privmsg(chan, "(=\"=)")
				serv.privmsg(chan, "( . )")
				serv.privmsg(chan, "(\")(\")")
			
			# Kick?
			elif "!kick " in message and nick in ["agent00tai", "kalikiana", "aroman", "lallenlowe", "Marin_M"] and message.split("!kick ")[1].lower().strip() != "rabbitbot":
				serv.kick(chan, message.split("!kick ")[1])
				
			elif "!kick " in message and nick in ["agent00tai", "kalikiana", "aroman", "lallenlowe", "Marin_M"]:
				serv.privmsg(chan, "I'm not so stupid.")
			
			# Logs?
			elif "!logs" in message.lower():
				params = urllib.urlencode({'api_option': 'paste', 'api_dev_key': 'b0c821ef533aba71de7b6c35869688d6', 'api_paste_code': self.logs})
				f = urllib.urlopen("http://pastebin.com/api/api_post.php", params)
				
				serv.notice(nick, f.read())
			
			# Translate
			elif "!translate " in message.lower():
				languages = {"AFRIKAANS": "af", "ITALIAN": "it", "ALBANIAN": "sq", "JAPANESE": "ja", "ARABIC": "ar", "KOREAN": "ko", "BELARUSIAN": "be", "LATVIAN": "lv", "BULGARIAN": "bg", "LITHUANIAN": "lt", "CATALAN": "ca", "MACEDONIAN": "mk", "CHINESE": "zh", "MALAY": "ms", "CHINESE_SIMPLIFIED": "zh-CN", "MALTESE": "mt", "CHINESE_TRADITIONAL": "zh-TW", "NORWEGIAN": "no", "CROATIAN": "hr", "PERSIAN": "fa", "CZECH": "cs", "POLISH": "pl", "DANISH": "da", "PORTUGUESE": "pt", "DUTCH": "nl", "PORTUGUESE_PORTUGAL": "pt-PT", "ENGLISH": "en", "ROMANIAN": "ro", "ESTONIAN": "et", "RUSSIAN": "ru", "FILIPINO": "tl", "SERBIAN": "sr", "FINNISH": "fi", "SLOVAK": "sk", "FRENCH": "fr", "SLOVENIAN": "sl", "GALICIAN": "gl", "SPANISH": "es", "GERMAN": "de", "SWAHILI": "sw", "GREEK": "el", "SWEDISH": "sv", "HAITIAN_CREOLE": "ht", "TAGALOG": "tl", "HEBREW": "iw", "THAI": "th", "HINDI": "hi", "TURKISH": "tr", "HUNGARIAN": "hu", "UKRAINIAN": "uk", "ICELANDIC": "is", "VIETNAMESE": "vi", "INDONESIAN": "id", "WELSH": "cy", "IRISH": "ga", "YIDDISH": "yi"}
				langcodes = ["sv", "lt", "hi", "tl", "nl", "th", "tl", "vi", "sq", "ht", "fa", "es", "ko", "af", "zh-CN", "pt", "id", "fi", "de", "zh-TW", "ja", "fr", "pl", "ga", "hu", "ro", "no", "ru", "sw", "da", "is", "tr", "iw", "sl", "be", "gl", "el", "sk", "en", "it", "et", "uk", "cs", "ms", "pt-PT", "yi", "mt", "hr", "cy", "mk", "lv", "sr", "ar", "bg", "zh", "ca"]
				
				if message.split("!translate")[1].strip().upper() in languages:
					self.translate[nick] = languages[message.split("!translate")[1].strip().upper()]
					serv.notice(nick, "Type something, I'll translate.")
					
				elif message.split("!translate")[1].strip().lower() == "off" and nick in self.translate:
					del self.translate[nick]
					
				elif message.split("!translate")[1].strip().lower() in langcodes:
					self.translate[nick] = message.split("!translate")[1].strip().lower()
					serv.notice(nick, "Type something, I'll translate.")
					
				else:
					serv.notice(nick, "Please enter a the name of a language, like french, german or spanish, or \"off\".")
			
			# AutoVoice
			elif "!voice " in message.lower() and nick in ["agent00tai", "kalikiana", "aroman", "lallenlowe", "Marin_M"]:
				open("../voice", "a").write(message.split("!voice")[1].strip().lower() + "\n")
				serv.mode(chan, "+v " + message.split("!voice")[1].strip())
			
			# UnAutoVoice
			elif "!unvoice " in message.lower() and nick in ["agent00tai", "kalikiana", "aroman", "lallenlowe", "Marin_M"]:
				content = open("../voice", "r").read()
				open("../voice", "w").write(content.replace(message.split("!unvoice")[1].strip().lower() + "\n", ""))
				serv.mode(chan, "-v " + message.split("!unvoice")[1].strip())
			
			else:
				# Grrrrr...
				grr = ["apple", "microsoft", "steeve", "steve"]
				grreed = False
				for i in grr:
					if grreed is False:
						if i in message.lower():
							serv.privmsg(chan, "Grrrrrr...")
							grreed = True

				# Autotranslate
				if nick in self.translate:
					r = urllib.urlopen("http://ajax.googleapis.com/ajax/services/language/translate?v=1.0&q=" + urllib.quote(str(message)) + "&langpair=" + self.translate[nick] + "%7Cen")
					serv.privmsg(chan, "\"" + json.loads(unicode(r.read()))["responseData"]["translatedText"].replace("&#39;", "'").replace("&quot;", "\"") + "\"")
		except:
			import sys
			serv.privmsg(chan, "BOOM")
			serv.notice("Marin_M", str(sys.exc_info()[0]) + ", " + str(sys.exc_info()[1]))
			self.memserv.append(["Marin_M", str(sys.exc_info()[0]) + ", " + str(sys.exc_info()[1])])
			
	# /me
	def on_action(self, serv, ev):
		try:
			chan = ev.target()
			message = ev.arguments()[0]
			nick = irclib.nm_to_n(ev.source())
			
			# Logs
			self.logs += "* " + nick + " " + message + "\n"
			
			# Apple
			grr = ["apple", "microsoft", "steeve"]
			grreed = False
			for i in grr:
				if grreed is False:
					if i in message.lower():
						serv.privmsg(chan, "Grrrrrr...")
						grreed = True
						
			# Autotranslate
			if nick in self.translate:
				r = urllib.urlopen("http://ajax.googleapis.com/ajax/services/language/translate?v=1.0&q=" + urllib.quote(message) + "&langpair=" + self.translate[nick] + "%7Cen")
				
				reponse = json.loads(r.read())["responseData"]["translatedText"].replace("&#39;", "'")
				
				if reponse != message:
					serv.privmsg(chan, "\"" + nick + " " + reponse + "\"")

		except:
			import sys
			serv.privmsg(chan, "BOOM")
			serv.notice("Marin_M", str(sys.exc_info()[0]) + ", " + str(sys.exc_info()[1]))
			self.memserv.append(["Marin_M", str(sys.exc_info()[0]) + ", " + str(sys.exc_info()[1])])

	# On join
	def on_join(self, serv, ev):
		try:
			chan = ev.target()
			nick = irclib.nm_to_n(ev.source())
			
			# Logs
			self.logs += "* " + nick + " got connected.\n"
			
			# AutoOP
			if nick in ["ammonkey", "agent00tai", "kalikiana", "aroman", "lallenlowe", "Marin_M"]:
				serv.execute_delayed(35, serv.mode, (chan, "+o " + nick))
			
			# AutoVoice
			elif chan == "#elementary-dev":
				voiced = open("../voice", "r").read().split("\n")
				if nick.lower() in voiced:
					serv.mode(chan, "+v " + nick)
				else:
					serv.notice(nick, "This channel is for developer talk only, if you need help or support, please go to #elementary.")
			
			# MemServ
			for i in self.memserv:
				if i[1] == nick:
					serv.notice(nick, "Message from " + i[0] + ": " + i[2])
					self.memserv.remove(i)

		except:
			import sys
			serv.privmsg(chan, "BOOM")
			serv.notice("Marin_M", str(sys.exc_info()[0]) + ", " + str(sys.exc_info()[1]))
			self.memserv.append(["Marin_M", str(sys.exc_info()[0]) + ", " + str(sys.exc_info()[1])])

	# On quit
	def on_quit(self, serv, ev):
		nick = irclib.nm_to_n(ev.source())
		self.logs += "* " + nick + " got disconnected.\n"
		
Rabbit().start()
